## com.fasterxml.jackson.databind.deser
Class CreatorProperty

    java.lang.Object
      com.fasterxml.jackson.databind.deser.SettableBeanProperty
          com.fasterxml.jackson.databind.deser.CreatorProperty

All Implemented Interfaces:
  BeanProperty, Named, Serializable

    public class CreatorProperty

extends SettableBeanProperty

This concrete sub-class implements property that is passed via Creator (constructor or static factory method). It is not a full-featured implementation in that its set method should never be called -- instead, value must separately passed.

Note on injectable values: unlike with other mutators, where deserializer and injecting are separate, here we deal the two as related things. This is necessary to add proper priority, as well as to simplify coordination.

See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.BeanProperty
`BeanProperty.Std`

Field Summary
`protected AnnotatedParameter` `_annotated` Placeholder that represents constructor parameter, when it is created from actual constructor.
`protected int` `_creatorIndex`
`protected Object` `_injectableValueId` Id of value to inject, if value injection should be used for this parameter (in addition to, or instead of, regular deserialization).

Fields inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty
`_contextAnnotations, _managedReferenceName, _nullProvider, _propertyIndex, _propName, _type, _valueDeserializer, _valueTypeDeserializer, _viewMatcher`

Constructor Summary
`protected` `CreatorProperty(CreatorProperty src, JsonDeserializer<?> deser)`
`protected` `CreatorProperty(CreatorProperty src, String newName)`
`` `CreatorProperty(String name, JavaType type, TypeDeserializer typeDeser, Annotations contextAnnotations, AnnotatedParameter param, int index, Object injectableValueId)`

Method Summary
`void` `deserializeAndSet(JsonParser jp, DeserializationContext ctxt, Object instance)` Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism.
`Object` `deserializeSetAndReturn(JsonParser jp, DeserializationContext ctxt, Object instance)` Alternative to `SettableBeanProperty.deserializeAndSet(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext, java.lang.Object)` that returns either return value of setter method called (if one is), or null to indicate that no return value is available.
`Object` `findInjectableValue(DeserializationContext context, Object beanInstance)` Method that can be called to locate value to be injected for this property, if it is configured for this.

`

`<A extends Annotation> A`

`

`getAnnotation(Class<A> acls)`
Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.

`int` `getCreatorIndex()` Method for accessing index of the creator property: for other types of properties will simply return -1.
`Object` `getInjectableValueId()` Accessor for id of injectable value, if this bean property supports value injection.
`AnnotatedMember` `getMember()` Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
`void` `inject(DeserializationContext context, Object beanInstance)` Method to find value to inject, and inject it to this property.
`void` `set(Object instance, Object value)` Method called to assign given value to this property, on specified Object.
`Object` `setAndReturn(Object instance, Object value)` Method called to assign given value to this property, on specified Object, and return whatever delegating accessor returned (if anything)
`String` `toString()`
`CreatorProperty` `withName(String newName)` Fluent factory method for constructing and returning a new instance with specified propert name.
`CreatorProperty` `withValueDeserializer(JsonDeserializer<?> deser)` Fluent factory method for constructing and returning a new instance with specified value deserializer.

Methods inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty
`_throwAsIOE, _throwAsIOE, assignIndex, deserialize, getContextAnnotation, getDeclaringClass, getManagedReferenceName, getName, getPropertyIndex, getType, getValueDeserializer, getValueTypeDeserializer, hasValueDeserializer, hasValueTypeDeserializer, hasViews, setManagedReferenceName, setViews, visibleInView`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### _annotated

    protected final AnnotatedParameter _annotated

  Placeholder that represents constructor parameter, when it is created from actual constructor. May be null when a synthetic instance is created.

### _injectableValueId

    protected final Object _injectableValueId

  Id of value to inject, if value injection should be used for this parameter (in addition to, or instead of, regular deserialization).

### _creatorIndex

    protected final int _creatorIndex

Since:
  2.1

Constructor Detail

### CreatorProperty

    public CreatorProperty(String name,
                           JavaType type,
                           TypeDeserializer typeDeser,
                           Annotations contextAnnotations,
                           AnnotatedParameter param,
                           int index,
                           Object injectableValueId)

Parameters:
  `name` - Name of the logical property
  `type` - Type of the property, used to find deserializer
  `typeDeser` - Type deserializer to use for handling polymorphic type information, if one is needed
  `contextAnnotations` - Contextual annotations (usually by class that declares creator [constructor, factory method] that includes this property)
  `param` - Representation of property, constructor or factory method parameter; used for accessing annotations of the property
  `index` - Index of this property within creator invocatino

### CreatorProperty

    protected CreatorProperty(CreatorProperty src,
                              String newName)

### CreatorProperty

    protected CreatorProperty(CreatorProperty src,
                              JsonDeserializer<?> deser)

Method Detail

### withName

    public CreatorProperty withName(String newName)

  Description copied from class: `SettableBeanProperty`
  Fluent factory method for constructing and returning a new instance with specified propert name. Note that this method should NOT change configuration of this instance.

  Specified by:
    `withName` in class `SettableBeanProperty`
  Parameters:
    `newName` - Name to use for the new instance.
  Returns:
    Newly constructed instance, if property name differs from the one used for this instance; or 'this' if not.

### withValueDeserializer

    public CreatorProperty withValueDeserializer(JsonDeserializer<?> deser)

  Description copied from class: `SettableBeanProperty`
  Fluent factory method for constructing and returning a new instance with specified value deserializer. Note that this method should NOT change configuration of this instance.

  Specified by:
    `withValueDeserializer` in class `SettableBeanProperty`
  Parameters:
    `deser` - Deserializer to assign to the new property instance
  Returns:
    Newly constructed instance, if value deserializer differs from the one used for this instance; or 'this' if not.

### findInjectableValue

    public Object findInjectableValue(DeserializationContext context,
                                      Object beanInstance)

  Method that can be called to locate value to be injected for this property, if it is configured for this.

### inject

    public void inject(DeserializationContext context,
                       Object beanInstance)
                throws IOException

  Method to find value to inject, and inject it to this property.

  Throws:
    `IOException`

### getAnnotation

    public <A extends Annotation> A getAnnotation(Class<A> acls)

  Description copied from interface: `BeanProperty`
  Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.

  Specified by:
    `getAnnotation` in interface `BeanProperty`
  Specified by:
    `getAnnotation` in class `SettableBeanProperty`

### getMember

    public AnnotatedMember getMember()

  Description copied from interface: `BeanProperty`
  Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.

  Specified by:
    `getMember` in interface `BeanProperty`
  Specified by:
    `getMember` in class `SettableBeanProperty`

### getCreatorIndex

    public int getCreatorIndex()

  Description copied from class: `SettableBeanProperty`
  Method for accessing index of the creator property: for other types of properties will simply return -1.

  Overrides:
    `getCreatorIndex` in class `SettableBeanProperty`

### deserializeAndSet

    public void deserializeAndSet(JsonParser jp,
                                  DeserializationContext ctxt,
                                  Object instance)
                           throws IOException,
                                  JsonProcessingException

  Description copied from class: `SettableBeanProperty`
  Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism. Pre-condition is that passed parser must point to the first token that should be consumed to produce the value (the only value for scalars, multiple for Objects and Arrays).

  Specified by:
    `deserializeAndSet` in class `SettableBeanProperty`
  Throws:
    `IOException`
    `JsonProcessingException`

### deserializeSetAndReturn

    public Object deserializeSetAndReturn(JsonParser jp,
                                          DeserializationContext ctxt,
                                          Object instance)
                                   throws IOException,
                                          JsonProcessingException

  Description copied from class: `SettableBeanProperty`
  Alternative to `SettableBeanProperty.deserializeAndSet(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext, java.lang.Object)` that returns either return value of setter method called (if one is), or null to indicate that no return value is available. Mostly used to support Builder style deserialization.

  Specified by:
    `deserializeSetAndReturn` in class `SettableBeanProperty`
  Throws:
    `IOException`
    `JsonProcessingException`

### set

    public void set(Object instance,
                    Object value)
             throws IOException

  Description copied from class: `SettableBeanProperty`
  Method called to assign given value to this property, on specified Object.

  Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.

  Specified by:
    `set` in class `SettableBeanProperty`
  Throws:
    `IOException`

### setAndReturn

    public Object setAndReturn(Object instance,
                               Object value)
                        throws IOException

  Description copied from class: `SettableBeanProperty`
  Method called to assign given value to this property, on specified Object, and return whatever delegating accessor returned (if anything)

  Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.

  Specified by:
    `setAndReturn` in class `SettableBeanProperty`
  Throws:
    `IOException`

### getInjectableValueId

    public Object getInjectableValueId()

  Description copied from class: `SettableBeanProperty`
  Accessor for id of injectable value, if this bean property supports value injection.

  Overrides:
    `getInjectableValueId` in class `SettableBeanProperty`

### toString

    public String toString()

  Overrides:
    `toString` in class `SettableBeanProperty`

Copyright © 2012 FasterXML. All Rights Reserved.